local nkGenie, privateVars = ...

-- irgendwann muss hier ein unterscheider zwischen auto height/width und gesetzten werten rein

function nkGenie.ExtText:new (name, parent)

	local this = {}
	this.name = name
	this.parent = parent	
	
	this.element = UI.CreateFrame("Text", name, parent)
	this.props = {}
	
	setmetatable(this, self)
	self.__index = self
	return this
	
end

function nkGenie.ExtText:checkProps(attribute, value) return nkGenie.Tools.checkProps(self, attribute, value) end
function nkGenie.ExtText:checkAnchorUpdate(newAnchors) return nkGenie.Tools.checkAnchorUpdate(self, newAnchors) end

function nkGenie.ExtText:update(settings)
	
	if settings == nil then return end
	if settings.template ~= nil then
		for k, v in pairs (settings.template) do if settings[k] == nil then settings[k] = v end end
		settings.template = nil
	end

	if self:checkProps('fontsize', settings.fontsize) == true then self.element:SetFontSize(settings.fontsize) end
	if self:checkProps('wordwrap', settings.wordwrap) == true then self.element:SetWordwrap(settings.wordwrap) end	
	
	-- Testen ob man das hier optimieren kann
	
	if settings.height == nil and self.props.height == nil then 
--		self.element:ClearHeight()		
	elseif settings.height ~= nil then
		self.element:SetHeight(math.floor(settings.height))
	else
		self.element:SetHeight(math.floor(self.props.height))
	end		
	
	if self:checkProps('autowidth', settings.autowidth) == true then 
		-- Fr die Kompatibilitt, wird gelscht sobald ich autowidth berall entfernt habe
		settings.width = nil
		self.props.width = nil
	end
	
	if settings.width == nil and self.props.width == nil then
	--	self.element:SetWidth(self.element:GetFullWidth())
	elseif settings.width ~= nil then
		self.element:SetWidth(settings.width)
	else
		self.element:SetWidth(self.props.width)
	end
	
	if settings.color ~= nil then
		local alpha = settings.alpha or 1
		local color = nkGenie.Tools:HexToRGB (settings.color)

		self.element:SetFontColor(color[1], color[2], color[3], alpha)
	end
	
	if settings.anchors ~= nil and self:checkAnchorUpdate (settings.anchors) == true then
		if self.props.anchors ~= nil then
			for k, anchor in pairs (self.props.anchors) do self.element:ClearPoint (anchor.from) end
		end
	
		for k, anchor in pairs(settings.anchors) do
			if anchor.x ~= nil and anchor.y ~= nil then
				self.element:SetPoint (anchor.from, anchor.object, anchor.to, anchor.x, anchor.y)
			else
				self.element:SetPoint (anchor.from, anchor.object, anchor.to)
			end
		end	
	end	
	
	if self:checkProps('visible', settings.visible) == true then self.element:SetVisible(settings.visible) end
	if self:checkProps('layer', settings.layer) == true then self.element:SetLayer(settings.layer) end
	
	if self:checkProps('font', settings.font) == true then self.element:SetFont (settings.path, settings.font) end	
	
	if self:checkProps('text', settings.text) == true then 
		if settings.height == nil and self.props.height == nil then self.element:ClearHeight() end
		if settings.width == nil and self.props.width == nil then self.element:ClearWidth() end
		
		self.element:SetText(tostring(settings.text)) 
	end
	
	for k, v in pairs (settings) do self.props[k] = v end

end

function nkGenie.ExtText:SetEvent(event, func)

	local element = self:getElement(false)

	if event == "LeftClick" then
		function element.Event:LeftClick() func(element)  end
	elseif event == "LeftDown" then
		function element.Event:LeftDown() func(element)  end
	elseif event == "MouseMove" then
		function element.Event:MouseMove() func(element)  end
	elseif event == "LeftUp" then
		function element.Event:LeftUp() func(element)  end
	elseif event == "MouseIn" then
		function element.Event:MouseIn() func(element)  end
	elseif event == "MouseOut" then
		function element.Event:MouseOut() func(element)  end
	end

end
	
function nkGenie.ExtText:getElement() return self.element end

function nkGenie.ExtText:GetWidth() 

	return self:getElement():GetWidth()
--	if self.props.width == nil then self.props.width = self:getElement():GetWidth() end
--	return self.props.width
end

function nkGenie.ExtText:GetHeight() 
	
	return self:getElement():GetHeight()
	--if self.props.height == nil then self.props.height = self:getElement():GetHeight() end
	--return self.props.height
end

function nkGenie.ExtText:getText() 
	if self.props.text == nil then self.props.text = self:getElement():GetText() end
	return self.props.text
end

function nkGenie.ExtText:SetVisible(flag) 

	if self:checkProps('visible', flag) == true then 
		self:getElement():SetVisible(flag) end
		self.props.visible = flag
	end
		
function nkGenie.ExtText:SetLayer(layer) 

	if self:checkProps('layer', layer) == true then 
		self:getElement():SetLayer(layer) 
		self.props.layer = layer
	end
	
end

function nkGenie.ExtText:ClearWidth() 
	
	self.props.width = nil
	self:getElement():ClearWidth() 
	
end